HISTORY of eParaksts Java Libraries
===================================

Version 2.13.1_01, 2026-04-09
-----------------------------
 - Fixed an error affecting the validation of electronic signatures issued in Ukraine.

Version 2.13.0_01, 2026-01-20
-----------------------------
 - Added support for EU Third Countries AdES List of Trusted Lists (TC AdES LOTL).
 - Added 'lv.eparaksts.helpers.ValidationHelper' class to obtain additional validation info.
 - Added 'lv.eparaksts.validation.SignatureValidationResult' class to obtain qualification data.
 - Added 'getSignatureResult(String signatureId)' method in 'lv.eparaksts.validation.ValidationResult'.

Version 2.12.0_01, 2025-10-15
-----------------------------
 - Improved support for LATVIA eID smartcards.
 - Improved PDF signature creation - use EU Trusted List. 
 - Added support for EU Trusted List format version 6 (TLv6).

Version 2.11.0_01, 2025-02-25
-----------------------------
 - Improved support for LATVIA eID smartcards.

Version 2.10.0_01, 2025-01-14
-----------------------------
 - Added PKCS#11 support for ARM64.
 - Improved support for PDF validation.
 - Updated dependency 'IAIK PKCS#11 Wrapper for Java': version 1.6.12 (lib/pkcs11wrapper-1.6.12.jar).

Version 2.9.1_01, 2024-12-12
-----------------------------
 - Improved support for ASiC-E document containers.

Version 2.9.0_01, 2024-08-28
-----------------------------
 - Updated dependency 'Java Native Access': version 5.14.0 (lib/jna-5.14.0.jar).
 - Updated dependency 'IAIK PKCS#11 Wrapper for Java': version 1.6.10 (lib/pkcs11wrapper-1.6.10.jar).

Version 2.8.2_01, 2024-02-27
-----------------------------
 - Fixed error: in some situations the limit of the maximum number of references per Manifest was not increased.
 - Changed the default trust store resource type to PKCS12. Legacy configuration referencing JKS type is still supported and is handled automatically.

Version 2.8.1_01, 2023-12-04
-----------------------------
 - Updated signature validation - increased limit of the maximum number of references per Manifest to 200.

Version 2.8.0_01, 2023-09-27
-----------------------------
 - Java SE version 8 or newer is required.
 - Changed JAXB API used for XML processing to the 'jakarta' namespace. 
 - Added dependency 'Jakarta XML Binding API': version 3.0.1 (lib/jakarta.xml.bind-api-3.0.1.jar).
 - Added dependency 'JAXB Runtime': version 3.0.2 (lib/jaxb/jaxb-runtime-3.0.2.jar).
 - Updated dependency 'Apache XML Security For Java': version 3.0.2 (lib/xmlsec-3.0.2.jar).
 - Updated dependency 'Apache Log4j 2 API': version 2.20.0 (lib/log4j-api-2.20.0.jar).
 - Updated dependency 'API for SLF4J': version 2.0.9 (lib/slf4j-api-2.0.9.jar).

Version 2.7.5_01, 2023-04-12
-----------------------------
 - Updated signature validation - suspended check that certificate is related to a CA/QC.

Version 2.7.4_02, 2023-03-21
-----------------------------
 - Updated signature validation - check that certificate is related to a CA/QC.

Version 2.7.4_01, 2023-02-24
-----------------------------
 - Added support for PDF PAdES Document Time-stamp digital signatures (ETSI.RFC3161).
 - Added validation support for RSASSA-PSS signature algorithms in ASiC-E signatures.

Version 2.7.3_01, 2022-10-27
-----------------------------
 - Improved PDF signature validation performance.

Version 2.7.2_01, 2022-08-24
-----------------------------
 - Added support for ECC smartcards.
 - Removed obsolete configuration properties.
 - Extended tolerance period for some OCSP Non-Authorized Responders.

Version 2.7.1_01, 2022-04-12
-----------------------------
 - Updated signature validation.

Version 2.7.0_01, 2022-02-14
-----------------------------
 - Java SE version 8 or newer is required.
 - Updated 'Bouncy Castle Crypto Libraries': version 1.70.
 - Updated logging framework to 'Apache Log4j 2 API': version 2.17.1.
 - Deprecated 'lv.eparaksts.helpers.TimeStampThread'.
 - Fixed error: support long file names in ASiC-E document containers.

Version 2.6.26_01, 2021-12-28
-----------------------------
 - Fixed issues with TSL when TSA certificate is from different issuer/subject territories

Version 2.6.25_01, 2021-11-08
-----------------------------
 - Fixed error: PDF signature field text encoding.
 - Extended tolerance period for checks whether OCSP producedAt is later than TimeStamp.

Version 2.6.24_01, 2021-10-22
-----------------------------
 - Near-field communication (NFC) support for eID cards.

Version 2.6.23_01, 2021-08-04
-----------------------------
 - Extended tolerance period for checks whether OCSP producedAt is later than TimeStamp.

Version 2.6.22_01, 2021-07-01
-----------------------------
 - Extended tolerance period for some OCSP Non-Authorized Responders.
 - Updated signature validation - check that OCSP producedAt is later than TimeStamp.
 - Improved support for EU TSL - additional check for publication of a new version of LOTL.

Version 2.6.21_01, 2021-03-17
-----------------------------
 - Fixed error: use RFC 3986 style URIs in ASiC-E signatures.
 - Added tolerance period for some OCSP Non-Authorized Responders.

Version 2.6.20_01, 2021-02-24
-----------------------------
 - Fixed error: disallow OCSP Non-Authorized Responders.
 - Improved support for smartcards on Windows platforms.

Version 2.6.19_01, 2021-02-13
-----------------------------
 - Updated list of trusted certificates.

Version 2.6.18_01, 2021-01-12
-----------------------------
 - Java SE version 7u121, 8u111 or newer required.
 - Added support for 'Oberthur Technologies Cosmo v8.1 Card'.
 - Added support for TLSv1.2 in TimeStampThread (use 'getAuthSignatureAlgorithm()' method to find out the actual signature algorithm).
 - Improved support for smartcards on macOS and Linux platforms.
 - JAR files are signed with a new code signing certificate.

Version 2.6.17_01, 2020-08-10
-----------------------------
 - Fixed error: SSL handshake with new TLS1.2 implementation.

Version 2.6.16_01, 2020-06-05
-----------------------------
 - Fixed error: Unicode normalization in EDOC 2.0 DataObject.name.

Version 2.6.15_01, 2020-04-07
-----------------------------
 - Fixed security issue: OS version was exposed in EDOC 2.0 ZIP container comments field.
 - Improved support for EU TSL - added 'Citizen CA (Belgium Root CA4)' trusted certificate.

Version 2.6.14_01, 2020-03-10
-----------------------------
 - Disabled OCSP result cache.
 - Added support for ECDSA SHA-512 signature algorithms in ASiC-E signatures.

Version 2.6.13_01, 2019-12-11
-----------------------------
 - Improved support for ASiC-E document containers.

Version 2.6.12_01, 2019-09-10
-----------------------------
 - Improved support for smartcards on macOS and Linux platforms.

Version 2.6.11_01, 2019-09-02
-----------------------------
 - Improved support for IDEMIA 'LATVIA eID' smartcards.

Version 2.6.10_01, 2019-08-12
-----------------------------
 - Added support for IDEMIA 'LATVIA eID' smartcards.

Version 2.6.9_01, 2018-12-10
-----------------------------
 - Added support for TSA Client Certificate request property.

Version 2.6.8_01, 2018-07-12
-----------------------------
 - Added support for eParaksts NQC Certificate Authority.

Version 2.6.7_01, 2018-07-04
-----------------------------
 - Added support for ECDSA signature algorithms in PDF signatures.
 - Fixed error: EDOC 2.0 signature ID collision. 

Version 2.6.6_05, 2018-04-21
-----------------------------
 - Improved EDOC 1.0 document support by EDOC 2.0 API.

Version 2.6.6_04, 2018-03-20
-----------------------------
 - Improved support for European Commission's Trusted Status List.

Version 2.6.6_03, 2018-01-18
-----------------------------
 - Fixed error: TimeStampThread compatibility with TSA without client authentication.

Version 2.6.6_02, 2018-01-05
-----------------------------
 - Fixed error: TimeStampThread compatibility with TLSv1.1.

Version 2.6.6_01, 2017-12-01
-----------------------------
 - Improved support for TSL.
 - Improved support for eParaksts Certificate Authority.

Version 2.6.5_01, 2017-09-01
-----------------------------
 - Added support for eParaksts Certificate Authority.
 - Added support for 'Oberthur Technologies Cosmo v7.0.1 Card'.
 - Fixed error: temporary file collision in multithreaded environments. 

Version 2.6.4_01, 2017-05-11
-----------------------------
 - Improved support for TSL.

Version 2.6.3_01, 2017-03-27
-----------------------------
 - Discontinued support for applets.

Version 2.6.2_01, 2017-03-09
-----------------------------
 - Allow usage of SHA-1 signature algorithm for EDOC signatures.

Version 2.6.1_01, 2017-03-03
-----------------------------
 - SHA-1 collision detection.

Version 2.6.0_01, 2017-02-28
-----------------------------
 - Disallow usage of SHA-1.

Version 2.5.14_01, 2017-02-15
-----------------------------
 - Updated EDOC 2.0 signature validation: improved revocation freshness check.
 - Fixed error: incorrectly resolved mimetype in the EDOC 2.0 manifest declaration.

Version 2.5.13_01, 2016-11-28
-----------------------------
 - Fixed error: disallow XML external entities.

Version 2.5.12_01, 2016-10-27
-----------------------------
 - Updated PDF signature validation: added support for European Commission's Trusted Status List. 

Version 2.5.11_01, 2016-09-22
-----------------------------
 - Updated PDF signature validation: full revocation data is mandatory. 

Version 2.5.10_01, 2016-08-02
-----------------------------
 - Improved TSL processing performance.
 - Improved support for smartcards on Windows 10.

Version 2.5.9_01, 2016-07-01
----------------------------
 - Improved support for TSL.

Version 2.5.8_01, 2016-05-23
----------------------------
 - Added support for TSL proxy.
 - Improved support for LT eID smartcards.

Version 2.5.7_01, 2016-02-25
----------------------------
 - Added support for European Commission's Trusted Status List.
 - Added support for Estonian BDOC and ASiC-E document containers.

Version 2.5.6_01, 2016-01-21
----------------------------
 - Improved support for EE eID smartcards.
 - JAR files are resigned with a new code signing certificate.

Version 2.5.5_04, 2015-12-23
----------------------------
 - Minor bug fix in EDOC format '2.0' implementation (European format).

Version 2.5.5_03, 2015-12-17
----------------------------
 - Improved support for LV eID smartcards.

Version 2.5.5_02, 2015-12-14
----------------------------
 - Minor bug fix in PDF signature API implementation.

Version 2.5.5_01, 2015-12-07
----------------------------
 - Fixed error: disallow redundant names in the EDOC ZIP container.
 - Fixed error: incorrectly encoded path names in the EDOC 2.0 manifest declaration.

Version 2.5.4_01, 2015-08-06
----------------------------
 - Fixed error: incorrect Zulu timezone in EDOC format '2.0' implementation.
 - Fixed error: EDOC 2.0 can not be opened with attachment containing a plus sign '+' in it's name.
 - Fixed error: PDF with multiple signatures does not include full revocation data. 
 - Improved PDF visual signature implementation.

Version 2.5.3_01, 2015-07-03
----------------------------
 - Fixed missing font bug in PDF signature API.

Version 2.5.2_01, 2015-06-30
----------------------------
 - Fixed signature oversize bug in PDF signature API.
 - Improved 'nCipher JCE Provider' support for EDOC format '2.0' implementation (European format).
 - Improved support for EE eID smartcards.

Version 2.5.1_01, 2015-05-21
----------------------------
 - Added PDF 'adbe.pkcs7.detached' signature validation functionality.
 - Improved support for EE eID smartcards.

Version 2.5.0_01, 2015-05-08
----------------------------
 - Added PDF signature API in 'lv.eparaksts.pdf'.
 - Added unified validation API in 'lv.eparaksts.validation'.
 - Added new trusted certificate: E-ME PSI (PCA), SHA-1: 97eba0706e231bb15d22c75fa3dfdb055c371215.
 - Updated documentation.

Version 2.4.0_04, 2015-03-17
----------------------------
 - Added support for 'Estonian Identity Card v3.5'.
 - Minor bug fix in EDOC format '2.0' implementation (European format).
 - Updated documentation.

Version 2.4.0_03, 2015-02-27
----------------------------
 - Added 'nCipher JCE Provider' support for EDOC format '2.0' implementation (European format).

Version 2.4.0_02, 2015-02-18
----------------------------
 - Minor bug fix in EDOC format '2.0' implementation (European format).

Version 2.4.0_01, 2015-02-12
----------------------------
 - Introduced a unified jar 'eparaksts-lib-{version}.jar'.
 - Added distributed computing support for EDOC 2.0 signatures.
 - Added EDOC 2.0 batch processing in 'lv.eparaksts.helpers.EDoc2Batch'.
 - Added EDOC 1.0 document support by EDOC 2.0 API in 'lv.eparaksts.edoc.EDoc2Builder'.
 - Integrated 'Bouncy Castle Crypto Libraries' in 'eparaksts-bc-1.43.0.jar'.
 - Updated documentation.

Version 2.3.0_03, 2015-01-08
----------------------------
 - Minor bug fix in EDOC format '2.0' implementation (European format).

Version 2.3.0_02, 2014-12-03
----------------------------
 - Minor bug fix in EDOC format '2.0' implementation (European format).

Version 2.3.0_01, 2014-11-24
----------------------------
 - Java SE version 7 or newer is required.
 - EDOC format '2.0' implementation (European format).
 - Added support for EE and LT eID smartcards.
 - Redesign the exception handling.
 - Updated documentation.

Version 2.2.11_02, 2014-09-02
-----------------------------
 - Removed testing environmet TrustStore resource from 'edoc-{version}.jar'.

Version 2.2.11_01, 2014-08-12
-----------------------------
 - Added new trusted certificate: E-ME SI (CA1), SHA-1: b73926c20e7ed9fbc6b0ddbdc25fba6a501dd78c.
 - Updated applet: only verified signature level for simple signature type.
 - Updated documentation.

Version 2.2.10_01, 2014-03-03
-----------------------------
 - Added new trusted certificate: E-ME SI (CA1), SHA-1: 0b8153cf4a8b4a1823481d651b182c4c21b92ae2.
 - Updated documentation.

Version 2.2.9_01, 2014-02-05
----------------------------
 - Added EDOC configuration property 'xml.transform.TransformerFactory.impl'.
 - Added EDOC configuration property 'xml.parsers.DocumentBuilderFactory.impl'.
 - Updated documentation.

Version 2.2.8_01, 2014-01-21
----------------------------
 - Updated EDOC configuration 'card....pkcs11.module' property names,
   added wildcards '*' to support Gemalto smart card recognition by using ATR masks.
 - Updated TrustStore: the missing intermediate certificates are loaded dinamically from the Internet.
 - Updated TokenProviderDynamicStore: loadKeyStore finalizes all loaded PKCS11 modules on a non Windows systems.
 - Updated ZipOutputStream: use 4KB buffer.
 - Updated documentation.

Version 2.2.7_01, 2013-11-25
----------------------------
 - Updated applets: added manifest attributes required by Java 7u45.
 - Updated documentation.

Version 2.2.6_01, 2013-10-07
----------------------------
 - Added new trusted certificate: E-ME SI (CA1), SHA-1: adc6ebdc4608cf11828339750b680f9c5f2645bf.
 - Updated documentation.

Version 2.2.5_01, 2013-08-28
----------------------------
 - Fixed error: removal of existing EDOC signatures caused invalid EDOC files.
 - Added 'getSignedDigest()' method in 'lv.pasts.eme.edoc.EDOCSignature'.
 - Updated applet: added visible signed digest value.
 - Updated documentation.

Version 2.2.4_01, 2013-06-28
----------------------------
 - Fixed XML signature error introduced by Java 7u25.
 - Added support for new eParaksts smartcards.
 - Updated documentation.

Version 2.2.3_01, 2013-05-20
----------------------------
 - Added EDOC configuration property 'edoc.format.version'.
 - Added applet configuration property 'edoc.format.version'.
 - Added portal applet configuration property 'edoc.ssl.truststore.internal'.
 - Added 'signing-applet-{version}.jar' archive Trusted-Library Attribute.
 - Updated EDOCBuilder: new EDOC documents are created using format '1.02' by default.
 - Updated documentation.

Version 2.2.2_01, 2013-04-29
----------------------------
 - Added new trusted certificate: E-ME SI (CA1), SHA-1: d5f2cb43a366d61a02a21259f262569c1c26a048.
 - Updated documentation.

Version 2.2.1_02, 2013-03-26
----------------------------
 - Added compatibility with Oracle WebLogic Server version 12.
 - Updated documentation.

Version 2.2.1_01, 2013-03-21
----------------------------
 - Added EDOC configuration property 'url.stream.handler.<protocol>'.
 - Added 'isDigitalSeal()' method in 'lv.pasts.eme.edoc.EDOCSignature'.
 - Added 'setFormatVersionDefault(String)' method in 'lv.pasts.eme.edoc.EDOCBuilder'.
 - Updated EDOCBuilder: new EDOC documents are created using format '1.01' by default.
 - Updated applet: new status images for digital signatures and digital seals.
 - Updated PIN administration applet: only numbers are allowed for a new PIN.
 - Updated documentation.

Version 2.2.0_01, 2013-03-05
----------------------------
 - EDOC format '1.02' implementation (XAdES-C without CRL data).
 - JAR files are resigned with a new code signing certificate.
 - Updated documentation.

Version 2.1.2_01, 2013-01-24
----------------------------
 - Added compatibility with Bouncy Castle version 1.46.
 - Added compatibility with Oracle WebLogic Server version 10.
 - Updated documentation.

Version 2.1.1_03, 2012-12-10
----------------------------
 - Fixed prepared signature verify implementation.

Version 2.1.1_02, 2012-12-04
----------------------------
 - Added 'signing-applet-{version}.jar' archive containing the Signing Applet implementation.
 - Updated documentation.

Version 2.1.1_01, 2012-11-20
----------------------------
 - Added PIN Administration Applet implemented in 'lv.eme.client.PINAdminApplet' class.
 - Updated EDOC file read/write operations: memory optimization.
 - Updated documentation.

Version 2.1.0_01, 2012-11-01
----------------------------
 - Added 'lv.pasts.eme.edoc.EDOCPreparedSignature' class.
 - Added 'prepareSignature(SignatureType, X509Certificate)' method in 'lv.pasts.eme.edoc.EDOC'.
 - Added Signing Applet implemented in 'lv.eme.client.SigningApplet' class.
 - Removed previously deprecated API.
 - Updated CRL manager: memory optimization.
 - Updated EDOC Java Libraries license.
 - Updated documentation.

Version 2.0.0_01, 2012-03-01
----------------------------
 - Java SE version 6 Update 10 or newer is required.
 - Added support for Java SE version 7.
 - Added support for Java SE 64-bit versions.
 - Added support for LATVIA eID smartcards.
 - Removed previously deprecated API.
 - Redesigned 'lv.pasts.eme.smartcard.CardAccessorCallback' interface.
 - Updated applet: redesigned PIN dialog by adding card and certificate info.
 - Updated EDOC Java Libraries configuration regarding smartcards.
 - Updated EDOC Java Libraries license.
 - Updated documentation.
 - This version does not involve any changes to EDOC format,
   EDOC signatures, certificate validation, and time stamp support.

Version 1.4.6_02, 2012-02-01
----------------------------
 - Added EDOC configuration property 'zip.impl'.
 - Fixed javax.xml.crypto.URIReferenceException issue introduced in JRE 7u1.

Version 1.4.6_01, 2011-08-18
----------------------------
 - Fixed EDOC validation algorithm to handle certificates issued by unknown CA.
 - Fixed SigningTime format to conform XAdES standard.

Version 1.4.5_01, 2011-06-16
----------------------------
 - Updated applet: only basic and verified levels for simple signature type.

Version 1.4.4_01, 2011-02-22
----------------------------
 - Added 'validateCertStatusUsingOCSP(X509Certificate, Date, boolean)' method in 'lv.pasts.eme.cert.CertValidator'.
 - Updated CRL manager: on update also check the CRLNextPublish date.
 - Fixed EDOC unzip algorithm to handle ZIPs without directory entries.
 - Updated documentation.

Version 1.4.3_02, 2010-06-17
----------------------------
 - Force PKCS11 session logout to avoid native PIN dialog.
 - Updated documentation.

Version 1.4.3_01, 2010-06-10
----------------------------
 - Fixed certificate parsing issue introduced by EME CSP V2.
 - Updated documentation.

Version 1.4.2_04, 2010-05-05
----------------------------
 - Fixed TLS renegotiation issue introduced in JRE 6u19.
 - Updated documentation.

Version 1.4.2_03, 2010-04-10
----------------------------
 - JAR files are resigned with a new code signing certificate.

Version 1.4.2_02, 2010-03-25
----------------------------
 - Removed TSA and OCSP certificates from TrustStore.
 - Fixed error: online CRLs were loaded during validation of a verified signature.

Version 1.4.2_01, 2010-03-10
----------------------------
 - Added 'lv.pasts.eme.edoc.EDOCSignatureContext' class.
 - Added 'addSignature(EDOCSignatureContext)' method in 'lv.pasts.eme.edoc.EDOC'.
 - Added EDOC validation support for IBM J9 VM.
 - Added EDOC configuration property 'edoc.temp.dir'.
 - Added EDOC configuration property 'edoc.user.name'.
 - Updated certificate validation: OCSP response caching.
 - Updated documentation.

Version 1.4.1, 2009-08-31
-------------------------
 - Updated EDOC signature validation: fixed OCSP time grace period.
 - Updated documentation.

Version 1.4.0, 2009-06-15
-------------------------
 - Java SE version 5.0 or later is supported.
 - Added new "E-ME" trusted certificates.
 - Added 'lv.pasts.eme.cert.CRLData' class.
 - Added 'lv.pasts.eme.cert.TrustStore' class.
 - Added 'getCRLs(X509Certificate)' method in 'lv.pasts.eme.cert.CRLManager'.
 - Added 'validateCertStatusUsingOCSP(BigInteger, String, String, Date)' method in 'lv.pasts.eme.cert.CertValidator'.
 - Added 'validateCertStatusUsingOCSP(X509Certificate, Date)' method in 'lv.pasts.eme.cert.CertValidator'.
 - Added 'REASON_CERT_EXPIRED' field in 'lv.pasts.eme.cert.CertValidatorException'.
 - Added 'REASON_CERT_NOT_YET_VALID' field in 'lv.pasts.eme.cert.CertValidatorException'.
 - Added 'saveTo(File, int)' method in 'lv.pasts.eme.edoc.EDOC'.
 - Added 'saveTo(OutputStream, int)' method in 'lv.pasts.eme.edoc.EDOC'.
 - Added 'validateSigningCertificate()' method in 'lv.pasts.eme.tsp.TimeStamp'.
 - Added 'validateSignature(PublicKey)' method in 'lv.pasts.eme.tsp.TimeStamp'.
 - Added 'requestTimeStamp(byte[], KeyStore.Builder, String, String)' method in 'lv.pasts.eme.tsp.TimeStampGenerator'.
 - Added EDOC configuration property 'pkcs11.module.name.macosx'.
 - Added EDOC configuration property 'cert.truststore.jks'.
 - Added EDOC configuration property 'tsp.responder.url.%SubjectKeyIdentifier%'.
 - Deprecated 'getLocalCRLUpdate()' method in 'lv.pasts.eme.cert.CRLManager'.
 - Deprecated 'getURL(X509CRL)' method in 'lv.pasts.eme.cert.CRLManager'.
 - Deprecated 'updateLocalCRL()' method in 'lv.pasts.eme.cert.CRLManager'.
 - Deprecated 'findCACertificate(String subject)' method in 'lv.pasts.eme.cert.CertManager'.
 - Deprecated 'generateCertPath(X509Certificate certificate)' method in 'lv.pasts.eme.cert.CertManager'.
 - Deprecated 'getIssuingCA1Certificate()' method in 'lv.pasts.eme.cert.CertManager'.
 - Deprecated 'getIssuingCA2Certificate()' method in 'lv.pasts.eme.cert.CertManager'.
 - Deprecated 'getOCSPCertificate()' method in 'lv.pasts.eme.cert.CertManager'.
 - Deprecated 'getPolicyCACertificate()' method in 'lv.pasts.eme.cert.CertManager'.
 - Deprecated 'getRootCACertificate()' method in 'lv.pasts.eme.cert.CertManager'.
 - Deprecated 'getTrustAnchors()' method in 'lv.pasts.eme.cert.CertManager'.
 - Deprecated 'getTrustedCert(CertPath certPath)' method in 'lv.pasts.eme.cert.CertManager'.
 - Deprecated 'validateCertStatusUsingOCSP(BigInteger, String, Date)' method in 'lv.pasts.eme.cert.CertValidator'.
 - Deprecated 'addSignature(EDOCCallback)' method in 'lv.pasts.eme.edoc.EDOC'.
 - Deprecated 'sign(EDOCSource[], EDOCBatchCallback, EDOCCallback)' method in 'lv.pasts.eme.edoc.EDOCBatch'.
 - Deprecated 'sign(EDOC[], EDOCBatchCallback, EDOCCallback)' method in 'lv.pasts.eme.edoc.EDOCBatch'.
 - Deprecated 'requestTimeStamp(byte[], CardAccessorCallback)' method in 'lv.pasts.eme.tsp.TimeStampGenerator'.
 - Redesigned CA certificate store to support multiple certification paths.
 - Renamed 'edoc_applet-{version}.jar' to 'edoc-client-{version}.jar'
 - Updated EDOC opening: optimized loading of the EDOC structure.
 - Updated EDOC signature validation: handling certificate expiration.
 - Updated EDOC signature creation and validation: TimeStamp validation is performed always.
 - Updated applet deployment: using Java Deployment Toolkit.
 - Updated portal applet: improved loading of the EDOC document.
 - Updated log4j configuration: added FILE appender sample.
 - Updated Bouncy Castle libraries: version 1.4.3.
 - Updated documentation.

Version 1.3.4, 2009-01-05
-------------------------
 - Added 'manageWindowsMyKeyStore(KeyStoreManagerCallback callback)' method in 'lv.pasts.eme.security.KeyStoreManager'.
 - Added 'manageWindowsRootKeyStore(KeyStoreManagerCallback callback)' method in 'lv.pasts.eme.security.KeyStoreManager'.
 - Added EDOC configuration property 'certpath.validate.oscp.responder.cert.subject'.
 - Updated EDOC signature validation: certificate path integrity check is performed always.
 - Updated applet: improved handling of the EDOC validation status.
 - Updated documentation.

Version 1.3.3, 2008-09-15
-------------------------
 - Added 'lv.pasts.eme.edoc.EDOCSignatureCallback' class.
 - Added 'lv.pasts.eme.security.CertificateEntry' class.
 - Added 'lv.pasts.eme.security.KeyAccessor' class.
 - Added 'lv.pasts.eme.security.KeyStoreManager' class.
 - Added 'lv.pasts.eme.security.KeyStoreManagerCallback' class.
 - Added 'addSignature(KeyAccessor, EDOCSignatureCallback)' method in 'lv.pasts.eme.edoc.EDOC'.
 - Added 'sign(EDOCSource[], EDOCBatchCallback, KeyAccessor, EDOCSignatureCallback)' method in 'lv.pasts.eme.edoc.EDOCBatch'.
 - Added 'sign(EDOC[], EDOCBatchCallback, KeyAccessor, EDOCSignatureCallback)' method in 'lv.pasts.eme.edoc.EDOCBatch'.
 - Added 'setCardAccessorCallback(CardAccessorCallback)' method in 'lv.pasts.eme.smartcard.CardAccessor'.
 - Added 'requestTimeStamp(byte[], KeyAccessor)' method in 'lv.pasts.eme.tsp.TimeStampGenerator'.
 - Added 'getReason()' method in 'lv.pasts.eme.tsp.TSPException'.
 - Updated documentation.

Version 1.3.2, 2008-06-09
-------------------------
 - Added 'search(String, String, String)' method in 'lv.pasts.eme.cert.CertManager'.
 - Added 'getSignatureTimeStamp()' method in 'lv.pasts.eme.edoc.EDOCSignature'.
 - Added 'getSignatureValueImprintDigest()' method in 'lv.pasts.eme.edoc.EDOCSignature'.
 - Added 'signData(byte[], String)' method in 'lv.pasts.eme.smartcard.CardAccessor'.
 - Deprecated 'lv.pasts.eme.edoc.EDOCSignatureTS' class.
 - Deprecated 'getTimeStamp()' method in 'lv.pasts.eme.edoc.EDOCSignature'.
 - Added EDOC configuration property 'ldap.provider.url'.
 - Updated applet: added an existing file overwrite confirmation, when using the 'Save as...' function.
 - Fixed classpath definition in applet sample HTML files.
 - Updated documentation.

Version 1.3.1, 2008-04-01
-------------------------
 - Added support for CRL testing environment.
 - Added 'lv.pasts.eme.tsp.TimeStamp' class.
 - Updated documentation.

Version 1.3.0, 2008-01-11
-------------------------
 - Java SE version 6.0 or later is required.
 - Removed dependency of Java XML Digital Signature library 'xmldsig-1.0.1.jar'.
 - Removed dependency of Java XML Security library 'xmlsec-1.0.1.jar'.
 - Added EDOC batch signing applet 'lv.pasts.eme.client.EDOCBatchApplet'.
 - Added 'lv.pasts.eme.edoc.EDOCBatch' class.
 - Added 'lv.pasts.eme.edoc.EDOCBatchCallback' class.
 - Added 'lv.pasts.eme.edoc.EDOCBatchException' class.
 - Added 'lv.pasts.eme.edoc.EDOCSource' class.
 - Added 'addFile(javax.activation.DataSource)' method in 'lv.pasts.eme.edoc.EDOC'.
 - Added 'newEDOC(lv.pasts.eme.edoc.EDOCTemplate)' method in 'lv.pasts.eme.edoc.EDOCBuilder'.
 - Added 'getSignatureValue()' method in 'lv.pasts.eme.edoc.EDOCSignature'.
 - Added 'reset()' method in 'lv.pasts.eme.smartcard.CardAccessor'.
 - Added 'lv.pasts.eme.tsp' package.
 - Updated EDOC signature validation: 'XADES-C' validation fails, if OCSP response time is before TimeStamp time.
 - Updated applet: added EDOC file printing function.
 - Updated applet: when only one certificate is available,
   the certificate selection dialog is skipped during signing procedure.
 - Updated applet: editable EDOC properties are always displayed before signing procedure.
 - Applet localization: LT.
 - Updated documentation.

Version 1.2.1, 2007-11-15
-------------------------
 - Updated code: when EDOC document was created using 'eParakstītājs v1.01 (1.1.0601.2)',
   it could not be properly validated on case-sensitive UNIX file systems.
 - Added HTTPS support for OCSP certificate checker.

Version 1.2.0, 2007-09-20
-------------------------
 - Fixed error: when applet was initialized, the native part of the IAIK Smartcard access library was not deployed correctly.
 - Fixed error: 'Target' attribute in the '_rels/.rels' file was formed usign the unnecessary '/' prefix.
 - Fixed error: in some cases 'lv.pasts.eme.client.EDOCPortalApplet' could not evaluate JavaScript
   using the 'Applet.getAppletContext().showDocument(URL url)' method -
   changed to the 'netscape.javascript.JSObject.getWindow(Applet applet).eval(String s)' method.
 - Added EDOC format validation: EDOC format '1.0.0' is not supported.
 - Added EDOC configuration property 'pkcs11.module.name.linux'.
 - Applet localization: LV, RU, EN.
 - Updated documentation.

Version 1.1.0, 2007-04-02
-------------------------
 - Fixed error: when applet is destroyed, the currently opened EDOC document was not closed.
 - Fixed error: signature properties were not correctly saved in the signature.xml file.
 - Fixed error: '/EDoc/Signature/origin.sgns' was saved even if no signatures were present.
 - Added 'openEDOC(InputStream, String, EDOCLoadParameter)' method in 'lv.pasts.eme.edoc.EDOCBuilder'.
 - Added 'templateLoadFailed(String, String, String)' method in 'lv.pasts.eme.edoc.EDOCBuilder.EDOCBuilderCallback'.
 - Added 'getCardPIN(boolean)' method in 'lv.pasts.eme.smartcard.CardAccessorCallback'.
 - Added native part of the IAIK Smartcard access library for LINUX platform (lib/native/linux/libpkcs11wrapper.so).
 - Updated code: in some cases 'javax.xml.validation.SchemaFactory' could not be created
   using the 'newSchema(URL schema)' method - changed to the 'newSchema(Source schema)' method.
 - Updated configuration (edoc.properties): property 'certpath.useTestChain' is 'false' by default.
 - Fixed some minor bugs.

Version 1.0.1, 2007-01-25
-------------------------
 - Updated documentation.

Version 1.0.0, 2007-01-12
-------------------------
 - Initial release.
